!zone resident {
.resident_include
!src "config.inc"
!convtab pet
!cpu 6510

;XXX TODO could be saved, 3 bytes overhead for SMC needed then
;loader zp-addresses
.readblock	= $04
.filenum	= .readblock

;depacker zp-addresses
.lz_dst		= $05
.lz_bits	= $07

!if BITFIRE_INCLUDE_LOADCOMPD = 1 {
	!if BITFIRE_INCLUDE_DECOMP = 0 {
		!error "Cant't include LOADCOMPD without DECOMP."
	}
} else {
bitfire_load_addr_hi = .filenum			;in case of no loadcompd, store the highbyte of loadaddress separatedly
}

bitfire_resident_	= *
.open_file
		inc .skip_la			;transform bpl next_block into ora ($xx),y for the first run
bitfire_send_byte_
		;jsr bitfire_set_atn_		;lines are always free when floppy is idle, no need to set lines
		sec				;insert bit as counter
		ror				;fetch first bit and set marker bit
		sta .filenum			;save value
		ldx #$3f			;start value, is also our mask
		txa
.bit_loop
		and #$ef			;clear bit 4
		adc #$20			;toggle bit 5 and set bit 4 depending on carry -> adc #$20/21
		ora #$0f			;set all lower bits again for next round

		sax $dd02			;only write out lower 6 bits
		lsr .filenum			;fetch next bit from filenumber
		bne .bit_loop			;last bit?
.slow
!if BITFIRE_CONFIG_NTSC = 1 {
		nop
}
		nop				;wait a bit
		stx $dd02			;all lines low again
		rts

!if BITFIRE_INCLUDE_LOADCOMPD = 0 {
bitfire_loadraw_
		jsr .open_file			;easy, open...
		jsr .slow
}
.pollblock
		lda $dd00
		anc #$c0			;focus on bit 7 and 6 and copy bit 7 to carry (set if floppy is idle/eof is reached)

!if BITFIRE_INCLUDE_LOADCOMPD = 1 {
		bne .ret			;only fetch block if both bits are 0 (floppy !idle + block_ready)
		txa
		pha
		;stx .save_x+1			;save x, but only if loadcompd is in use XXX TODO could be substituted with txa pha/pla tax
} else {
		bne .poll_end			;if loadraw only is enabled, skip the blockfetch part and loop
}
		lda #$60			;set rts
		jsr bitfire_ack_		;signal that we accept data, by basically sending 2 atn strobes by fetching a bogus byte (6 bits could also be used for status? (first two bits might be broken))
.skip_la
		bpl .next_block			;BRA - will be changed into a ora ($xx),y for first run to fall through to the upcoming codeblock else it is a BRA as jsr bitfire_ack_ will return with a positive number (y = 0)

;----------------------------------------------------
;only execute this code here once
;----------------------------------------------------

		dec .skip_la			;$11 (ora ($xx),y -> $10 bpl -> lock out again to make the upcoming code execute once
		jsr .get_one_byte_no + 2	;fetch loadaddr hi - XXX TODO jsr to different routine that either fetches own address or saved address store old value in y and do iny afterwards? then get_one_byte could end after blockpos ldy #$xx
!if BITFIRE_INCLUDE_DECOMP = 1 {		;decompressor only needs to be setup if there
bitfire_decomp_addr1
		sta bitfire_lz_sector_ptr1 + 1
		sta bitfire_lz_sector_ptr2 + 1
		sta bitfire_lz_sector_ptr3 + 1
}
bitfire_load_addr1
		sta bitfire_load_addr_hi	;need to save load_addr_hi seperatedly, as the sector_ptr* will be incremented and thus can't be used as load_addr, most of all if we want to reuse the laod_addr after loading

		jsr .get_one_byte_no + 2	;fetch loadaddr lo
!if BITFIRE_INCLUDE_DECOMP = 1 {		;decompressor only needs to be setup if there
bitfire_decomp_addr2
		sta bitfire_lz_sector_ptr1
		sta bitfire_lz_sector_ptr2
		sta bitfire_lz_sector_ptr3
}
bitfire_load_addr2
		sta bitfire_load_addr_lo	;destination lowbyte
;----------------------------------------------------

.next_block
		jsr .get_one_byte_no + 2	;get current block address highbyte
		sta .bitfire_block_addr_hi	;save it

!if BITFIRE_INCLUDE_LOADCOMPD = 1 {
		sec				;XXX TODO could be omitted if load_addr_hi would be send with offset of -1, or value is sent negative
bitfire_load_addr_hi = * + 1
		sbc #$00			;subtract load address highbyte to obtain index

		jsr .blockmappos		;mark block in blockmap, only needed for loadcompd
		sta bitfire_blockmap,y
}
		jsr .get_one_byte_no		;fetch blocklen - switch already set to rts, but need to set x again
bitfire_load_block
		tay
		lda #$a0
bitfire_ack_
		sta .blockpos
.get_one_byte_no
		ldx #$37
.getloop
!if BITFIRE_CONFIG_NTSC {
		lda $dd00-$37,x
} else {
		lda $dd00
}
		stx $dd02
		lsr
		lsr
		sty .blockpos+1		;store initial y, and in further rounds do bogus writes with correct y value anyway, need to waste 4 cycles, so doesn't matter. Saves a byte (tay + sty .blockpos+1) copared to sta .blockpos+1 + nop + nop.
		ldy #$3f

!if BITFIRE_CONFIG_NTSC {
		ora $dd00-$37,x
} else {
		ora $dd00
}
		sty $dd02
		lsr
		lsr
		dec .blockpos+1		;waste 6 cycles and decrement

!if BITFIRE_CONFIG_NTSC {
		ora $dd00-$37,x		;now ATN is 0 and ora can happen without killing bit 3
} else {
		ora $dd00
}
		stx $dd02
		lsr
		asr #$7e		;clear carry for free
		sta .nibble + 1
		lda #$c0

!if BITFIRE_CONFIG_NTSC {
		and $dd00-$37,x
} else {
		and $dd00
}
		sty $dd02
.nibble		ora #$00		;also adc could be used, or sbc -nibble?
.blockpos	ldy #$00
.bitfire_block_addr_hi = * + 2
bitfire_load_addr_lo = * + 1
		sta $4000,y
		bne .getloop		;74 cycles per loop

!if >* != >.getloop = 1 { !error "getloop code crosses page!" }
!if BITFIRE_INCLUDE_LOADCOMPD = 1 {
;.save_x		ldx #$00
		pla
		tax
.ret
		rts

bitfire_loadraw_
		jsr .open_file		;easy, open...
-
		jsr .lz_fetch_sector	;use this verion to load blocks, as loaded blocks are logged in blockmap, thus blockmap is clean after load again
		bcc -
		rts
} else {
.poll_end
		bcc .pollblock
		rts
}

!if BITFIRE_INCLUDE_DECOMP = 1 {
;---------------------------------------------------------------------------------
; REFILL ROUTINES
;---------------------------------------------------------------------------------

.lz_refill_bits
bitfire_lz_sector_ptr1	= * + 1
		ldy $beef,x
		sty .lz_bits
		rol .lz_bits
		inx
		bne .lz_no_fetch
.lz_next_sector
		inc bitfire_lz_sector_ptr1 + 1
		inc bitfire_lz_sector_ptr2 + 1
		inc bitfire_lz_sector_ptr3 + 1

!if BITFIRE_INCLUDE_LOADCOMPD = 0 {
.lz_no_fetch
.lz_end_of_file
		rts
bitfire_decomp_
} else {
.lz_skip_fetch	php			;will be changed to rts in case of plain decomp
		pha			;save A
		tya
		pha
		jsr .lz_fetch_sector
		pla			;restore regs + flags
		tay
		pla
		plp
.lz_no_fetch
		rts

.lz_fetch_sector
-
		lda .readblock		;number of wanted block
		jsr .blockmappos	;check in blockmap
		ldx #$00		;reset x to start new block @ x = 0
		cmp bitfire_blockmap,y	;any change in blockmap? -> carry set if not
		bcc +			;carry clear, so wanted block is there, exit. Works as buffer is filled from bit 7 to 0, so a compare moves the blockbit to carry (all previous bits are cleared already, as they are processed)
		jsr .pollblock		;fetch another block, leaves x either untouched or returns with x = 0
		bcc -			;eof reached, nothing more to fetch?
		txa			;write a bogus 0 to blockmap, not needed, but 1 byte shorter then a branch
+
		sta bitfire_blockmap,y	;clear block on success
		inc .readblock		;bump blockcounter
		rts

.blockmappos
		ldx #$07
		sbx #$00		;save lower 3 bits in x
		lsr
		lsr
		lsr
		;XXX TODO could limit buffer by using a wraparound like asr #$1e, but when starving loader then too many blocks might be loaded before being depeacked
		tay			;select block by doing >> 3
		lda bitfire_blockmap,y
		eor .bl_bits,x
.lz_end_of_file
		rts

bitfire_loadcomp_
		jsr .open_file
		;lda #$00
		;sta .readblock		;start with readpos = 0 -> is always zero as it is shifted empty on open_file
		jsr .lz_fetch_sector	;fetch first block to have some data to work with (depackaddr). Will also set load_addr_lo. Clears X.
		ldy #(.lz_maybe_gblock - .lz_skip_en - 2)		;enable call to lz_maybe_gblock	y = 4
		lda #$08		;php
		bne .loadcompd_entry	;go!
bitfire_decomp_
		ldy #(.lz_maybe_skip - .lz_skip_en - 2)			;disable call to lz_maybe_gblock y = 7
		lda #$60		;end lz_fetch_sector in time -> transforms nop to rts
.loadcompd_entry
		sta .lz_skip_fetch
		sty .lz_skip_en + 1
}
		;load_addr is already set by loadraw_/pollblock

;---------------------------------------------------------------------------------
; DECRUNCHER
;---------------------------------------------------------------------------------

		;******** Start the next match/literal run ********
.lz_decrunch
		ldx #$00
-
		jsr .lz_refill_bits	;fetch depack addr
		sty .lz_dst-1,x		;x = 1 and x = 2
		cpx #$02
		bne -

		;sec			;This is the main entry point. Forcibly
.lz_type_refill	jsr .lz_refill_bits	;fill up the the bit buffer on entry
.lz_type_check
		bcc .lz_do_match
		beq .lz_type_refill	;We will fall through on entry

		;******** Process literal run ********

		lda #$00
-
		rol			;-> a = $01 after first round
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		bcc .lz_lrun_gotten

		asl .lz_bits
		bne -
		jsr .lz_refill_bits
		bne -

.lz_lrun_gotten
		sta .lz_lcopy_len	;Store LSB of run-length
		ldy #$00
.lz_lcopy
bitfire_lz_sector_ptr2	= * + 1		;Copy the literal data.
		lda $beef,x
		sta (.lz_dst),y
		inx
		bne *+5
		jsr .lz_next_sector
		iny
.lz_lcopy_len = * + 1
		cpy #$00
		bne .lz_lcopy

		;Time to advance the destination pointer.
		;Maximum run length literals exit here as a type-bit needs
		;to be fetched afterwards
		tya
		beq .lz_maximum		;maximum literal run, bump sector pointers and so on and force new type bit
		clc
		adc .lz_dst
		sta .lz_dst
		bcc *+4
		inc .lz_dst+1

		;One literal run following another only makes sense if the
		;first run is of maximum length and had to be split. As that
		;case has been taken care of we can safely omit the type bit
		;here


		;******** Process match ********

		;check bit -> 1 -> short match (len 2)
		;else long match

.lz_do_match
		lda #$01		;this could be made shorter by using the last bitfetch of the upcoming loop and restoring the carry again by a cmp #$02. Saves bytes, but makes things slower, as eof check is also done with all short matches then

		asl .lz_bits		;first length bit (where a one identifies
		bne *+5			;a two-byte match)
		jsr .lz_refill_bits
		bcc .lz_get_offs	;all done, length is 2, skip further bitfetches (and eof check)
-
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		rol

		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		bcc -

		tay
		beq .lz_end_of_file	;A 257-byte (=>$00) run serves as a
					;sentinel
.lz_get_offs
		sta .lz_mcopy_len	;store length at final destination
		lda #%11000000		;fetch 2 more prefix bits
		rol			;previous bit is still in carry \o/
-
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		rol
		bcs -

		tay
		lda .lz_lentab,y
		;eor #$ff		;XXX TODO 8 bits should be represented by $ff instead of $00 if 9 bits are used as well, else things can be made short. table needs to be inverted in that case
		beq .lz_far		;0 + 8 bits to fetch
-
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		rol
		bcs -
		bmi .lz_short		;either 3,4,6 or 7 bits fetched -> highbyte will be $ff
.lz_far
		eor #$ff		;7 of 15, 4 of 12 bits fetched as highbyte, lowbyte still to be fetched
		tay

bitfire_lz_sector_ptr3	= * + 1
		lda $beef,x		;For large offsets we can load the
		inx			;low-byte straight from the stream
		bne .lz_join		;without going throught the shift
		jsr .lz_next_sector	;register
		top
.lz_short
		ldy #$ff		;XXX TODO silly, y is set twice in short case
.lz_join
		adc .lz_dst		;subtract offset from lz_dst
		sta .lz_m_+1
		tya			;hibyte
		adc .lz_dst+1
		sta .lz_m_+2

		ldy #$ff		;The copy loop. This needs to be run
					;forwards since RLE-style matches can overlap the destination
.lz_mcopy
		iny
.lz_m_
		lda $beef,y		;Copy one byte
		sta (.lz_dst),y
.lz_mcopy_len	= * + 1
		cpy #$ff
		bne .lz_mcopy

		tya			;Advance destination pointer
;		sec
		adc .lz_dst
		sta .lz_dst
.lz_skip_en
		bcc .lz_maybe_skip
.lz_maximum	inc .lz_dst+1		;This is also used by maximum length

!if BITFIRE_INCLUDE_LOADCOMPD = 1 {
		bcs .lz_maybe_skip	;BRA, always skip, so we only need to manipulate one branch, carry is always set, also when entering via lz_maxiumum
.lz_maybe_gblock
		jsr .pollblock		;yes, fetch another block and mark block in bitmap
}

.lz_maybe_skip
					;literals needing an explicit type bit
		asl .lz_bits		;Fetch next type bit
		jmp .lz_type_check

		;******** Fetch some more bits to work with ********

.lz_lentab
		;short offset init values
		!byte %11011111
		!byte %11111011
		!byte %00000000
		!byte %10000000		;same as first byte of bl_bits, could be saved if tables are swapped

		;long offset init values
		!byte %11101111
		!byte %11111101
		!byte %10000000
		!byte %11110000

!if BITFIRE_INCLUDE_LOADCOMPD = 1 {
.bl_bits
		!byte $80,$40,$20,$10,$08,$04,$02,$01

!if BITFIRE_BLOCKMAP_ADDRESS = 0 {
bitfire_blockmap
		;XXX TODO theoretically we can only load from $0200-$d000 in a demo ($d0 blocks) so we would max need a blockbuffer of $1a bytes
		!byte $00,$00,$00,$00,$00,$00,$00,$00
		!byte $00,$00,$00,$00,$00,$00,$00,$00
		!byte $00,$00,$00,$00,$00,$00,$00,$00
		!byte $00,$00;,$00,$00,$00,$00,$00,$00
} else {
bitfire_blockmap = BITFIRE_BLOCKMAP_ADDRESS
}
}
}	;endif DECOMP
}	;!zone resident
